﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Infragistics.Web.Mvc;
using Lab1MVCjQueryGrid.Models;

namespace Lab1MVCjQueryGrid.Controllers
{ 
    public class ProdutcsController : Controller
    {
        ProductsDB db = new ProductsDB();

        public ActionResult Index()
        {
            var products = from p in db.Products
                           orderby p.ProductID
                           select p;
          
            return View(products.AsQueryable<Product>());
        }

        [GridDataSourceAction]
        [ActionName("UpdatingGetChanges")]
        public ActionResult UpdatingGetChanges()
        {
            var products = from p in db.Products
                           orderby p.ProductID
                           select p;
            return View(products.AsQueryable<Product>());
        }

        [ActionName("UpdatingSaveChanges")]
        public ActionResult UpdatingSaveChanges()
        {
            GridModel m = new GridModel();
            List<Transaction<Product>> transactions = m.LoadTransactions<Product>(HttpContext.Request.Form["ig_transactions"]);
            foreach (Transaction<Product> t in transactions)
            {
                if (t.type == "newrow")
                {
                    this.db.Products.Add(t.row);
                }
                else if (t.type == "deleterow")
                {
                    var rowid = Int32.Parse(t.rowId);
                    var product = (from p in this.db.Products
                                   where p.ProductID == rowid
                                   select p).Single();
                    this.db.Products.Remove(product);
                }
                else if (t.type == "row")
                {
                    var rowid = Int32.Parse(t.rowId);
                    var product = (from p in this.db.Products
                                   where p.ProductID == rowid
                                   select p).Single();                   
                    if (t.row.Name != null)
                    {
                        product.Name = t.row.Name;
                    }
                    if (t.row.ProductNumber != null)
                    {
                        product.ProductNumber = t.row.ProductNumber;
                    }
                    db.Entry(product).State = EntityState.Modified;
                }
            }
            db.SaveChanges();
            JsonResult result = new JsonResult();
            Dictionary<string, bool> response = new Dictionary<string, bool>();
            response.Add("Success", true);
            result.Data = response;
            return result;
        }
    }
}